package dev.shadowsoffire.apotheosis.adventure.compat;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.mojang.blaze3d.vertex.PoseStack;
import dev.shadowsoffire.apotheosis.adventure.Adventure;
import dev.shadowsoffire.apotheosis.adventure.affix.salvaging.SalvagingRecipe;
import dev.shadowsoffire.apotheosis.adventure.compat.AdventureJEIPlugin;
import java.util.Arrays;
import java.util.List;
import mezz.jei.api.constants.VanillaTypes;
import mezz.jei.api.gui.builder.IRecipeLayoutBuilder;
import mezz.jei.api.gui.drawable.IDrawable;
import mezz.jei.api.gui.ingredient.IRecipeSlotsView;
import mezz.jei.api.helpers.IGuiHelper;
import mezz.jei.api.ingredients.IIngredientType;
import mezz.jei.api.recipe.IFocusGroup;
import mezz.jei.api.recipe.RecipeIngredientRole;
import mezz.jei.api.recipe.RecipeType;
import mezz.jei.api.recipe.category.IRecipeCategory;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.Font;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.network.chat.Component;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.ItemLike;

public class SalvagingCategory implements IRecipeCategory<SalvagingRecipe> {
  public static final ResourceLocation TEXTURES = new ResourceLocation("apotheosis", "textures/gui/salvage_jei.png");
  
  private final Component title = (Component)Component.m_237115_("title.apotheosis.salvaging");
  
  private final IDrawable background;
  
  private final IDrawable icon;
  
  public SalvagingCategory(IGuiHelper guiHelper) {
    this.background = (IDrawable)guiHelper.drawableBuilder(TEXTURES, 0, 0, 98, 74).addPadding(0, 0, 0, 0).build();
    this.icon = guiHelper.createDrawableIngredient((IIngredientType)VanillaTypes.ITEM_STACK, new ItemStack((ItemLike)Adventure.Blocks.SALVAGING_TABLE.get()));
  }
  
  public RecipeType<SalvagingRecipe> getRecipeType() {
    return AdventureJEIPlugin.SALVAGING;
  }
  
  public Component getTitle() {
    return this.title;
  }
  
  public IDrawable getBackground() {
    return this.background;
  }
  
  public IDrawable getIcon() {
    return this.icon;
  }
  
  public void draw(SalvagingRecipe recipe, IRecipeSlotsView recipeSlotsView, GuiGraphics gfx, double mouseX, double mouseY) {
    List<SalvagingRecipe.OutputData> outputs = recipe.getOutputs();
    Font font = (Minecraft.m_91087_()).f_91062_;
    PoseStack pose = gfx.m_280168_();
    int idx = 0;
    for (SalvagingRecipe.OutputData d : outputs) {
      pose.m_85836_();
      pose.m_252880_(0.0F, 0.0F, 200.0F);
      String text = String.format("%d-%d", new Object[] { Integer.valueOf(d.getMin()), Integer.valueOf(d.getMax()) });
      float x = (59 + 18 * idx % 2) + 16.0F - font.m_92895_(text) * 0.5F;
      float y = 23.0F + (18 * idx / 2);
      float scale = 0.5F;
      pose.m_85841_(scale, scale, 1.0F);
      gfx.m_280488_(font, text, (int)(x / scale), (int)(y / scale), 16777215);
      idx++;
      pose.m_85849_();
    } 
  }
  
  public void setRecipe(IRecipeLayoutBuilder builder, SalvagingRecipe recipe, IFocusGroup focuses) {
    List<ItemStack> input = Arrays.asList(recipe.getInput().m_43908_());
    builder.addSlot(RecipeIngredientRole.INPUT, 5, 29).addIngredients((IIngredientType)VanillaTypes.ITEM_STACK, input);
    List<SalvagingRecipe.OutputData> outputs = recipe.getOutputs();
    int idx = 0;
    for (SalvagingRecipe.OutputData d : outputs) {
      builder.addSlot(RecipeIngredientRole.OUTPUT, 59 + 18 * idx % 2, 11 + 18 * idx / 2).addIngredient((IIngredientType)VanillaTypes.ITEM_STACK, d.getStack());
      idx++;
    } 
  }
}
